/*
// $Id: //guest/julian_hyde/saffron/src/main/openjava/ptree/AliasedExpression.java#2 $
// Saffron preprocessor and data engine
// Copyright (C) 2002 Julian Hyde <julian.hyde@mail.com>
// 
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
// 
// You should have received a copy of the GNU Library General Public
// License along with this library; if not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330,
// Boston, MA  02111-1307, USA.
// 
// See the COPYING file located in the top-level-directory of
// the archive of this library for complete text of license.
*/

package openjava.ptree;
import openjava.mop.Environment;
import openjava.mop.OJClass;
import java.io.PrintWriter;

public class AliasedExpression extends NonLeaf
    implements Expression
{
    String alias;

    public AliasedExpression(Expression expr, String alias)
    {
	set(expr);
	this.alias = alias;
    }

    public void accept(openjava.ptree.util.ParseTreeVisitor v)
	throws ParseTreeException
    {
        v.visit(this);
    }

    public Expression getExpression()
    {
	return (Expression) elementAt(0);
    }

    // implement Expression
    public OJClass getType(Environment env) throws Exception
    {
	Expression expr = getExpression();
	return expr.getType(env);
    }

    // implement Expression
    public OJClass getRowType(Environment env) throws Exception
    {
	Expression expr = getExpression();
	return expr.getRowType(env);
    }

    public String getAlias()
    {
	return alias;
    }
    
    public void setAlias(String alias)
    {
	this.alias = alias;
    }
};

// End AliasedExpression.java
