/*
// $Id: //guest/julian_hyde/saffron/src/main/saffron/ext/AbstractTable.java#1 $
// Saffron preprocessor and data engine
// Copyright (C) 2002 Julian Hyde <julian.hyde@mail.com>
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
//
// You should have received a copy of the GNU Library General Public
// License along with this library; if not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330,
// Boston, MA  02111-1307, USA.
//
// See the COPYING file located in the top-level-directory of
// the archive of this library for complete text of license.
//
// jhyde, May 3, 2002
*/

package saffron.ext;

import openjava.mop.OJClass;
import saffron.Schema;
import saffron.Table;

/**
 * A <code>AbstractTable</code> is a partial implementation of {@link Table}.
 *
 * @author jhyde
 * @since May 3, 2002
 * @version $Id: //guest/julian_hyde/saffron/src/main/saffron/ext/AbstractTable.java#1 $
 **/
public abstract class AbstractTable implements Table {
	Schema schema;
	String name;
	OJClass rowType;

	protected AbstractTable(Schema schema, String name, OJClass rowType) {
		this.schema = schema;
		this.name = name;
		this.rowType = rowType;
	}

	protected AbstractTable(Schema schema, String name, Class rowType) {
		this(schema, name, OJClass.forClass(rowType));
	}

	// implement Table
	public Schema getSchema() {
		return schema;
	}

	// implement Table
	public OJClass getRowType() {
		return rowType;
	}

	public String getName()
	{
		return name;
	}

	public double getRowCount()
	{
		return 100;
	}

}

// End AbstractTable.java
