/*
// $Id: //guest/julian_hyde/saffron/src/main/saffron/ext/ObjectSchema.java#3 $
// Saffron preprocessor and data engine
// Copyright (C) 2002 Julian Hyde <julian.hyde@mail.com>
// 
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
// 
// You should have received a copy of the GNU Library General Public
// License along with this library; if not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330,
// Boston, MA  02111-1307, USA.
// 
// See the COPYING file located in the top-level-directory of
// the archive of this library for complete text of license.
*/

package saffron.ext;

import junit.framework.TestSuite;
import saffron.Schema;

/**
 * <code>ObjectSchema</code> implements {@link saffron.Schema} by calling Java
 * methods.
 *
 * @author jhyde
 * @since 8 February, 2002
 * @version $Id: //guest/julian_hyde/saffron/src/main/saffron/ext/ObjectSchema.java#3 $
 **/
public abstract class ObjectSchema implements Schema {
	public ObjectSchema()
	{
	}

	// implement Connection
	public Object contentsAsArray(String tableName)
	{
		throw new UnsupportedOperationException(
			"JdbcConnection.contentsAsArray(" + tableName +
			") should have been replaced");
	}

	// for Connection
	public static Schema getSchemaStatic()
	{
		throw new UnsupportedOperationException(
			"Derived class must implement " +
			"public static Schema getSchemaStatic()");
	}

	/** Creates a test suite. **/
	public static TestSuite suite() throws Exception {
		Class clazz = Class.forName("saffron.test.ObjectSchemaTest");
		return new TestSuite(clazz);
	}
}

// End ObjectSchema.java
