/*
// $Id: //guest/julian_hyde/saffron/src/main/saffron/rel/plan/PlanFilter.java#2 $
// Saffron preprocessor and data engine
// Copyright (C) 2002 Julian Hyde <julian.hyde@mail.com>
// 
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
// 
// You should have received a copy of the GNU Library General Public
// License along with this library; if not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330,
// Boston, MA  02111-1307, USA.
// 
// See the COPYING file located in the top-level-directory of
// the archive of this library for complete text of license.
*/

package saffron.rel.plan;

import openjava.ptree.Expression;
import saffron.opt.CallingConvention;
import saffron.opt.Cluster;
import saffron.opt.Implementor;
import saffron.rel.Filter;
import saffron.rel.Rel;
import saffron.util.Util;

/**
 * <code>PlanFilter</code> implements {@link Filter} as a {@link
 * saffron.runtime.Plan} object.
 **/
public class PlanFilter extends Filter
{
    public PlanFilter(Cluster cluster, Rel child, Expression condition)
    {
        super(cluster, child, condition);
    }

    public Object clone()
    {
        return new PlanFilter(
            cluster, (Rel) child.clone(), Util.clone(condition));
    }

    // implement Rel
    public int getConvention()
    {
        return CallingConvention.PLAN;
    }

    // implement Rel
    public Object implement(Implementor implementor, int ordinal)
    {
//  			Plan plan = (Plan) child.implement(implementor, PLAN_CONVENTION);
//  			Expression conditionPlan = implementExp(
//  				condition, new Plan[] {plan});
//  			return new FilterPlan(plan, conditionPlan);
        throw new UnsupportedOperationException();
    }
}
