/*
// $Id: //guest/julian_hyde/saffron/src/main/saffron/util/RelVisitor.java#2 $
// Saffron preprocessor and data engine
// Copyright (C) 2002 Julian Hyde <julian.hyde@mail.com>
// 
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
// 
// You should have received a copy of the GNU Library General Public
// License along with this library; if not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330,
// Boston, MA  02111-1307, USA.
// 
// See the COPYING file located in the top-level-directory of
// the archive of this library for complete text of license.
*/

package saffron.util;

import saffron.rel.Rel;

/**
 * A <code>RelVisitor</code> is a Visitor role in the Visitor pattern and
 * visits {@link saffron.rel.Rel} objects as the role of Element.  Other
 * components in the pattern: {@link
 * saffron.rel.Rel#childrenAccept(RelVisitor)}.
 *
 * @author jhyde
 * @since 22 September, 2001
 * @version $Id: //guest/julian_hyde/saffron/src/main/saffron/util/RelVisitor.java#2 $
 **/
public abstract class RelVisitor {
    public void visit(Rel p, int ordinal, Rel parent)
	{
		p.childrenAccept(this);
	}
}


// End RelVisitor.java
